﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Input;
using TweakConsole;

namespace TweakConsoleTester
{
    public class Ship
    {
        private static Texture2D texShip;

        private static TweakFloat XSpeed = new TweakFloat("Ship_XSpeed",40.0f);
        private static TweakFloat YSpeed = new TweakFloat("Ship_YSpeed",30.0f);

        private Vector2 Velocity;
        private Vector2 Position, StartPosition;

        public Ship(Vector2 pos)
        {
            Position = pos;
            StartPosition = pos;
            GameConsole.AddFunction("Ship_ResetPosition", new ConsoleDelegate(this.ResetShipPosition));
            GameConsole.WriteLine("Ship Created");
        }

        public static void Load(ContentManager Content)
        {
            texShip = Content.Load<Texture2D>("ship");
        }

        public void Update(GameTime gameTime)
        {
            Vector2 tempVel = new Vector2();

            KeyboardState kbs = Keyboard.GetState();

            if (kbs.IsKeyDown(Keys.Left))
                tempVel.X -= 1;
            if (kbs.IsKeyDown(Keys.Right))
                tempVel.X += 1;
            if (kbs.IsKeyDown(Keys.Up))
                tempVel.Y -= 1;
            if (kbs.IsKeyDown(Keys.Down))
                tempVel.Y += 1;

            Velocity = tempVel * new Vector2(XSpeed, YSpeed);

            Position += Velocity * (float)gameTime.ElapsedGameTime.TotalSeconds;
        }

        public void Draw(SpriteBatch spriteBatch)
        {
            float rotation = (float)Math.Atan2(Velocity.Y * YSpeed, Velocity.X * XSpeed) + MathHelper.PiOver2;
            spriteBatch.Draw(texShip, Position, null, Color.White, rotation, new Vector2(texShip.Width * 0.5f, texShip.Height * 0.5f), 1, SpriteEffects.None, 0);
        }

        public void ResetShipPosition(String nothing)
        {
            Position = StartPosition;
        }
    }
}
